#include "struct.hpp"
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <FCNTL.H>
#include <SYS\STAT.H>
#include <string.h>

void liberar_regla(regla *r); //regla.cpp
char Ventana_confirmacion(char *Titulo,char * Linea1,char *Linea2,char *Linea3); // botones.cpp
void Ventana_errores(char * Linea1,char *Linea2,char *Linea3); //botones.cpp

void salvar_regla(int fd,regla *r)
	{
	 regla *p;
	 double result;
	 cnj_fuzzy *cnj;
	 lista_per *lp;
	 lista_per *q;

	 if ( r == NULL)
		return;

	 switch (r->operador)
		{
		 case EQ:
		 case AND:
		 case OR :
					write(fd, &r->operador,1);
					salvar_regla(fd,r->nodo.nohoja.izq);
					salvar_regla(fd,r->nodo.nohoja.der);
					break;
		 case NOT:
					write(fd, &r->operador,1);
					salvar_regla(fd,r->nodo.nohoja.izq);
					break;
		 case PER:
					{
					 int nv,nc;
					 vble *v;
					 cnj_fuzzy *c;
					 extern vble *vble_entrada;
					 extern vble *vble_salida;

					 write(fd, &r->operador,1);
					 nv = 0;
					 v = vble_entrada;
					 while ( v != NULL)
						{
						 nv ++;
						 if ( v == r->nodo.hoja.variable)
							break;
						 v = v->next;
						}
					 if ( v !=  r->nodo.hoja.variable)
						{
						 v = vble_salida;
						 while ( v != NULL)
							{
							 nv ++;
							 if ( v == r->nodo.hoja.variable)
								break;
							 v = v->next;
							}

						}

					 write(fd,&nv,sizeof(int));
					 c = v->conjuntos;
					 nc = 0;
					 while(c != NULL)
						{
						 nc ++;
						 if ( c == r->nodo.hoja.cnj)
							break;
						 c = c->next;
						}
					 write( fd,&nc,sizeof(int));
					 break;
					}
		}

	}



void salvar(char *nombre)
	{
	 extern unsigned char far *buf1;
	 extern unsigned char far *buf2;
	 extern unsigned char far *buf3;
	 extern unsigned char far *buf4;

	 extern vble *vble_entrada;
	 extern vble *vble_salida;
	 extern lis_reg *lista_reglas;
	 int n_entradas= 0 ;
	 int n_salidas= 0 ;
	 int i;
	 vble *p;
	 char fin = 0;
	 int cont;
	 int fd;
	 lis_reg *l;
	 int n_reglas = 0;
	 char *mn="%$&/";


	 // contar variables de entrada

	 p = vble_entrada;
	 n_entradas= 0;
	 while ( p != NULL)
		{
		 n_entradas ++;
		 p = p->next;
		}

	 //if ( vble_entrada == 0 )
	//	{
	//	 Ventana_errores("No existen variables de entrada","", "definidas en este sistema");
	//	 return;
	//	}
	 // contar variables de salida

	 p = vble_salida;
	 n_salidas= 0;
	 while ( p != NULL)
		{
		 n_salidas ++;
		 p = p->next;
		}

 //	 if ( vble_salida == 0 )
 //		{
 //		 Ventana_errores("No existen variables de salida","", "definidas en este sistema");
 //		 return;
 //		}

	fd = open(nombre,O_BINARY | O_RDONLY);
	if ( fd != -1)
		{
		 if ( !Ventana_confirmacion("SOBREESCRIBIR","El Fichero que existe," ,"", "Desea sobreescribirlo?"))
			{
			 return;
			}
		}
	close(fd);
	fd = open(nombre,O_BINARY|O_WRONLY|O_CREAT,S_IREAD|S_IWRITE);
	if ( fd == -1)
		{
		 Ventana_errores ( "Error intentando","","abrir el fichero");
		 return;
		}

	write(fd,mn,6);
	write(fd,&n_entradas,sizeof(int));
	p = vble_entrada;
	while ( p != NULL)
		{
		 int n_cnj;
		 cnj_fuzzy *c;
		 n_cnj = 0;

		 write(fd,p->nombre,255);
		 write(fd,&(p->tipo),1);
		 write(fd,&(p->min),sizeof(double));
		 write(fd,&(p->max),sizeof(double));
		 write(fd,p->fichero,255);

		 // contar el nmero de conjuntos
		 c = p->conjuntos;
		 while(c != NULL)
			{
			 n_cnj ++;
			 c = c->next;
			}
		 write(fd,&n_cnj,sizeof(int));
		 c = p->conjuntos;
		 while (c != NULL)
			{
			 write(fd,c->nombre,255);
			 write(fd,&c->tipo,1);
			 write(fd,&c->left,sizeof(double));
			 write(fd,&c->top_left,sizeof(double));
			 write(fd,&c->top_right,sizeof(double));
			 write(fd,&c->right,sizeof(double));
			 c = c->next;
			}
		 p = p->next;
		}


	write(fd,&n_salidas,sizeof(int));
	p = vble_salida;
	while ( p != NULL)
		{
		 int n_cnj;
		 cnj_fuzzy *c;
		 n_cnj = 0;

		 write(fd,p->nombre,255);
		 write(fd,&(p->tipo),1);
		 write(fd,&(p->min),sizeof(double));
		 write(fd,&(p->max),sizeof(double));
		 write(fd,p->fichero,255);

		 // contar el nmero de conjuntos
		 c = p->conjuntos;
		 while(c != NULL)
			{
			 n_cnj ++;
			 c = c->next;
			}
		 write(fd,&n_cnj,sizeof(int));
		 c = p->conjuntos;
		 while (c != NULL)
			{
			 write(fd,c->nombre,255);
			 write(fd,&c->tipo,1);
			 write(fd,&c->left,sizeof(double));
			 write(fd,&c->top_left,sizeof(double));
			 write(fd,&c->top_right,sizeof(double));
			 write(fd,&c->right,sizeof(double));
			 c = c->next;
			}
		 p = p->next;
		}

	l = lista_reglas;
	n_reglas;
	while ( l != NULL)
		{
		 n_reglas ++;
		 l = l->next;
		}
	write(fd,&n_reglas,sizeof(int));
	l = lista_reglas;
	while( l != NULL)
		{
		 salvar_regla(fd,l->reg);
		 l = l->next;
		}
	 close ( fd);
	}

void eliminar_sistema(void)
	{
	 extern vble *vble_entrada;
	 extern vble *vble_salida;
	 extern lis_reg *lista_reglas;

	 vble *v;
	 cnj_fuzzy *c;
	 lis_reg *l;

	 v = vble_entrada;

	 while ( v != NULL)
		{
		 c = v->conjuntos;
		 while ( c != NULL)
			{
			 v->conjuntos = c->next;
			 farfree(c);
			 c = v->conjuntos;
			}
		 vble_entrada = v->next;
		 farfree(v);
		 v = vble_entrada;
		}

	 vble_entrada = NULL;
	 v = vble_salida;

	 while ( v != NULL)
		{
		 c = v->conjuntos;
		 while ( c != NULL)
			{
			 v->conjuntos = c->next;
			 farfree(c);
			 c = v->conjuntos;
			}
		 vble_salida = v->next;
		 farfree(v);
		 v = vble_salida;
		}

	 vble_salida = NULL;

	 l = lista_reglas;
	 while ( l != NULL)
		{
		 liberar_regla(l->reg);
		 lista_reglas = l->next;
		 farfree(l);
		 l = lista_reglas;
		}
	 lista_reglas = NULL;
	}


regla *leer_regla(int fd)
	{
	 extern unsigned char far *buf1;
	 extern unsigned char far *buf2;
	 extern unsigned char far *buf3;
	 extern unsigned char far *buf4;

	 regla *r;
	 double result;
	 cnj_fuzzy *cnj;
	 lista_per *lp;
	 lista_per *q;

	 r = (regla *) farmalloc(sizeof(regla));
	 if ( r == NULL)
		{
		 printf("ERROR: memoria insufiente");
		 exit(-1);
		}


	 read(fd, &r->operador,1);

	 switch (r->operador)
		{
		 case EQ:
		 case AND:
		 case OR :
					r->nodo.nohoja.izq = leer_regla(fd);
					r->nodo.nohoja.der = leer_regla(fd);
					break;
		 case NOT:
					r->nodo.nohoja.izq = leer_regla(fd);
					break;
		 case PER:
					{
					 int nv,nc;
					 int i;
					 vble *v;
					 cnj_fuzzy *c;
					 extern vble *vble_entrada;
					 extern vble *vble_salida;


					 read(fd,&nv,sizeof(int));

					 v = vble_entrada;
					 i = 0;
					 while (( v != NULL) && ( i < nv))
						{
						 i ++;
						 if ( i == nv)
							break;
						 v = v->next;
						}
					 if ( v == NULL)
						{
						 v = vble_salida;
						 while (( v != NULL) && ( i < nv))
							{
							 i++;
							 if ( i == nv)
								break;
							 v = v->next;
							}

						}
					 r->nodo.hoja.variable = v;


					 read(fd,&nc,sizeof(int));
					 c = v->conjuntos;
					 i = 0;
					 while((c != NULL) && ( i < nc))
						{
						 i ++;
						 if ( i == nc)
							break;
						 c = c->next;
						}
					 r->nodo.hoja.cnj = c;
					 break;
					}
		}
	 return r;
	}




void abrir(char *nombre)
	{
	 extern unsigned char far *buf1;
	 extern unsigned char far *buf2;
	 extern unsigned char far *buf3;
	 extern unsigned char far *buf4;

	 extern vble *vble_entrada;
	 extern vble *vble_salida;
	 extern lis_reg *lista_reglas;
	 int n_entradas= 0 ;
	 int n_salidas= 0 ;
	 int i;
	 vble *p;
	 char fin = 0;
	 int cont;
	 int fd;
	 lis_reg *l,*anl;
	 int n_reglas = 0;
	 vble *v,*anv;
	 char *mn="%$&/";
	 char *pos_mn="11111";


	 // contar variables de entrada

	 if ( (vble_entrada != NULL) || vble_salida != NULL)
		{
		 if ( Ventana_confirmacion("Elimar sistema","Al cargar un nuevo fichero","se eliminar el sistema anterior","desea Coninuar con el proceso de carga?"))
			{
			 eliminar_sistema();
			}
		 else
			return;
		}

	fd = open(nombre,O_BINARY | O_RDONLY);
	if ( fd == -1)
		{
		 Ventana_errores ( "Error intentando","","abrir el fichero");
		 return;
		}
	read(fd,pos_mn,6);
	if ( strcmp(mn,pos_mn) != 0)
		{
		 Ventana_errores ("","Fichero con formato erroneo","");
		 return;

		}

	read(fd,&n_entradas,sizeof(int));

	for ( i = 0; i < n_entradas; i ++)
	  {
		int n_cnj;
		cnj_fuzzy *c,*anc;
		n_cnj = 0;
		int j;

		v = (vble *) farmalloc(sizeof(vble));
		if ( v == NULL)
		  {
			printf("ERROR: memoria insufiente");
			exit(-1);
		  }

		read(fd,v->nombre,255);
		read(fd,&(v->tipo),1);
		read(fd,&(v->min),sizeof(double));
		read(fd,&(v->max),sizeof(double));
		read(fd,v->fichero,255);
		v->conjuntos = NULL;

		read(fd,&n_cnj,sizeof(int));
		for (j = 0; j < n_cnj; j ++)
			{
			c = (cnj_fuzzy *) farmalloc(sizeof(cnj_fuzzy));
			if ( c == NULL)
			  {
				printf("ERROR: memoria insufiente");
				exit(-1);
			  }
			read(fd,c->nombre,255);
			read(fd,&c->tipo,1);
			read(fd,&c->left,sizeof(double));
			read(fd,&c->top_left,sizeof(double));
			read(fd,&c->top_right,sizeof(double));
			read(fd,&c->right,sizeof(double));
			c->ptr_lista = NULL;
			c->next = NULL;
			c->last = NULL;

			if ( j == 0)
			  {
				v->conjuntos = c;
				c->next = NULL;
				c->last = NULL;
            anc = c;
			  }
			else
			  {
				anc->next = c;
				c->last = anc;
				c->next = NULL;
				anc = c;
			  }
		  }
		if ( i == 0)
		  {
			vble_entrada = v;
			v->next = NULL;
			anv = v;
		  }
		else
		  {
			anv->next = v;
			v->next = NULL;
			anv = v;
		  }

	  }

	read(fd,&n_salidas,sizeof(int));

	for ( i = 0; i < n_salidas; i ++)
	  {
		int n_cnj;
		cnj_fuzzy *c,*anc;
		n_cnj = 0;
		int j;

		v = (vble *) farmalloc(sizeof(vble));
		if ( v == NULL)
		  {
			printf("ERROR: memoria insufiente");
			exit(-1);
		  }

		read(fd,v->nombre,255);
		read(fd,&(v->tipo),1);
		read(fd,&(v->min),sizeof(double));
		read(fd,&(v->max),sizeof(double));
		read(fd,v->fichero,255);

		read(fd,&n_cnj,sizeof(int));
		for (j = 0; j < n_cnj; j ++)
		  {
			c = (cnj_fuzzy *) farmalloc(sizeof(cnj_fuzzy));
			if ( c == NULL)
			  {
				printf("ERROR: memoria insufiente");
				exit(-1);
			  }
			read(fd,c->nombre,255);
			read(fd,&c->tipo,1);
			read(fd,&c->left,sizeof(double));
			read(fd,&c->top_left,sizeof(double));
			read(fd,&c->top_right,sizeof(double));
			read(fd,&c->right,sizeof(double));
			c->ptr_lista = NULL;
			c->next = NULL;
			c->last = NULL;

			if ( j == 0)
			  {
				v->conjuntos = c;
				c->next = NULL;
				c->last = NULL;
				anc = c;
			  }
			else
			  {
				anc->next = c;
				c->next = NULL;
				c->last = anc;
				anc = c;
			  }
		  }
		if ( i == 0)
		  {
			vble_salida = v;
			v->next = NULL;
         anv = v;
		  }
		else
		  {
			anv->next = v;
			v->next = NULL;
			anv = v;
		  }

	  }


	read(fd,&n_reglas,sizeof(int));
	for ( i  = 0; i < n_reglas; i ++)
		{
		 l = (lis_reg *) farmalloc(sizeof(lis_reg));
		 if ( l == NULL)
			{
			 printf("ERROR: memoria insufiente");
			 exit(-1);
			}
		 l->reg = leer_regla(fd);
		 if ( i == 0)
			{
			 lista_reglas = l;
			 l->next = NULL;
          anl  = l;
			}
		 else
			{
			 anl->next = l;
			 l->next = NULL;
			 anl = l;
			}
		}

	 close ( fd);
	}
