#include <graphics.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include <alloc.h>
#include "Graton.hpp"
#include "struct.hpp"

void activar_boton(int xup,int yup,int tamx,int tamy,int grosor); //botones.hpp
int barra(int x,int y,int tamx,char ** Opciones,int num_opc,int initopc,int buf); //variables.cpp
void desactivar_boton(int xup,int yup,int tamx,int tamy,int grosor); // botones.hpp
void dibujar_boton(int xup,int yup,int tamx,int tamy,int grosor,
				int COLOR_BOTON,int OPC);  // botones.cpp
char editar_regla(lis_reg *r);
void entrada(void); //"GRaton.cpp"
void mensaje(char *texto); // botones.cpp
void triangulo(int x1,int y1,int x2,int y2,int x3,int y3); // variable.cpp
char Ventana_confirmacion(char *Titulo,char * Linea1,char *Linea2,char *Linea3); // botones.cpp
void Ventana_errores(char * Linea1,char *Linea2,char *Linea3); //botones.cpp



char encontrar(regla *r,regla*p,int i,int *cont)
	{
	 if ( r == NULL)
		return 0;

	 if ( r->operador == PER)
		{
		 if ( i == *cont)
			{
			 farfree(r);
			 return 1;
			}
		 else
			{
			 *cont = *cont + 1;
			 return 0;
			}
		}
	 else
		{
		 char j;

		 j = encontrar(r->nodo.nohoja.izq,r,i,cont);
		 if ( j == 1)
			{
			 if ( p == r)
				{
				 r->nodo.nohoja.izq = NULL;
				}
			 else
				{
				 if ( r->operador == NOT)
					{
					 farfree(r);
					 return 1;
					}
				 if (p->nodo.nohoja.izq == r)
					 p->nodo.nohoja.izq = r->nodo.nohoja.der;
				 else
					 p->nodo.nohoja.der = r->nodo.nohoja.der;
				 farfree(r);
				}
			 return 2;
			}
		 if ( j == 2 )
			return 2;

     if ( r->operador == NOT)
     	{
       return 0;
      }
		 j = encontrar(r->nodo.nohoja.der,r,i,cont);
		 if ( j == 1)
			{
			 if ( p == r)
				{
				 r->nodo.nohoja.der = NULL;
				}
			 else
				{
				 if ( r->operador == NOT)
					{
					 farfree(r);
					 return 1;
					}
				 if (p->nodo.nohoja.izq == r)
					 p->nodo.nohoja.izq = r->nodo.nohoja.izq;
				 else
					 p->nodo.nohoja.der = r->nodo.nohoja.izq;
				 farfree(r);
				}
			 return 2;
			}
		 if ( j == 2 )
			return 2;

		}
	}


void borrar(regla *r, int i)
	{
	 int cont=0;
	 encontrar(r,r,i,&cont);
	}


void crear_regla(regla *r,char *buf)
	{
	 regla *p;
	 double result;
	 cnj_fuzzy *cnj;
	 lista_per *lp;
	 lista_per *q;

	 if ( r == NULL)
		return;

	 switch (r->operador)
		{
		 case EQ:
					crear_regla(r->nodo.nohoja.izq,buf);
					strcat( buf," -> ");
					crear_regla(r->nodo.nohoja.der,buf);
					break;
		 case AND:
					crear_regla(r->nodo.nohoja.izq,buf);
					strcat( buf," AND ");
					crear_regla(r->nodo.nohoja.der,buf);
					break;

		 case OR :
					crear_regla(r->nodo.nohoja.izq,buf);
					strcat( buf," OR ");
					crear_regla(r->nodo.nohoja.der,buf);
					break;
		 case NOT:
					strcat( buf," NOT ");
					crear_regla(r->nodo.nohoja.izq,buf);
					break;
		 case PER:
					strcat(buf,r->nodo.hoja.variable->nombre);
					strcat(buf,"  ");
					strcat(buf,r->nodo.hoja.cnj->nombre);
					break;
		}
	}


void encontrar_hojas(regla *r,char *names[],int *cont)
	{
	 regla *p;
	 double result;
	 cnj_fuzzy *cnj;
	 lista_per *lp;
	 lista_per *q;

	 if ( r == NULL)
		return;

	 switch (r->operador)
		{
		 case EQ:
					encontrar_hojas(r->nodo.nohoja.izq,names,cont);
					encontrar_hojas(r->nodo.nohoja.der,names,cont);
					break;
		 case AND:
					encontrar_hojas(r->nodo.nohoja.izq,names,cont);
					encontrar_hojas(r->nodo.nohoja.der,names,cont);
					break;

		 case OR :
					encontrar_hojas(r->nodo.nohoja.izq,names,cont);
					encontrar_hojas(r->nodo.nohoja.der,names,cont);
					break;
		 case NOT:
					encontrar_hojas(r->nodo.nohoja.izq,names,cont);
					break;
		 case PER:
					names[*cont] =(char *) farmalloc(255);
					if (names[*cont] == NULL)
						{
						 printf("ERROR : memoria insuficiente");
						 exit(-1);
						}
					strcpy(names[*cont],r->nodo.hoja.variable->nombre);
					strcat(names[*cont],"  ");
					strcat(names[*cont],r->nodo.hoja.cnj->nombre);
					(*cont)++;
					break;
		}
	}

void liberar_regla(regla *r)
	{
	 regla *p;
	 double result;
	 cnj_fuzzy *cnj;
	 lista_per *lp;
	 lista_per *q;

	 switch (r->operador)
		{
		 case EQ:
		 case AND:
		 case OR:
					liberar_regla(r->nodo.nohoja.izq);
					liberar_regla(r->nodo.nohoja.der);
					farfree(r);
					break;
		 case NOT:
					liberar_regla(r->nodo.nohoja.izq);
					farfree(r);
					break;
		 case PER:
					farfree(r);
					break;
		}
	}



void ventana_reglas(void)
{
 extern unsigned char far *buf1;
 extern unsigned char far *buf2;
 extern unsigned char far *buf3;

 int x=0,y=0,dimx=0,dimy=0;

 dimx=600;
 dimy=120;
 x=320-dimx/2;
 y=100;

 getimage(x,y,x+dimx,y+dimy,buf1);


 dibujar_boton(x,y,dimx,dimy,2,LIGHTGRAY,0);  // Recuadro total
 dibujar_boton(x+3,y+3,dimx-6,20,2,CYAN,1); // Titulo
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 setcolor(WHITE);
 outtextxy(x+dimx/2,y+13,"R E G L A S");

 setcolor(BLACK);
 settextjustify(LEFT_TEXT,CENTER_TEXT);
 outtextxy(x+10,y+40,"Regla :");
 dibujar_boton(x+80,y+30,480,20,2,WHITE,1);
 dibujar_boton(x+560,y+30,20,20,2,LIGHTGRAY,0);
 triangulo(x+565,y+35,x+575,y+35,x+570,y+45);

 dibujar_boton(x + 105 , y+70,60,30,2,LIGHTGRAY,0); /* nueva */
 setcolor(BLACK);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 outtextxy(x+135,y+85,"Crear");

 dibujar_boton(x + 270 , y+70,60,30,2,LIGHTGRAY,0);
 setcolor(BLACK);
 outtextxy(x+300,y+85,"Editar");

 dibujar_boton(x + 435 , y+70,60,30,2,LIGHTGRAY,0);
 setcolor(BLACK);
 outtextxy(x+465,y+85,"Borrar");

}


void reglas(void)
	{
	 extern unsigned char far *buf1;
	 extern unsigned char far *buf2;
	 extern unsigned char far *buf3;
	 extern vble *vble_entrada;
	 extern vble *vble_salida;
	 extern lis_reg *lista_reglas;
	 lis_reg *p=NULL;
   lis_reg *q=NULL;

	 extern GRaton raton;
	 extern int bi,bd,bc;
   extern int raton_boton;
   extern int cambio;

	 char *names[255];

	 int x,y,dimx,posx,posy;
	 int ultimo= -1;

	 dimx=600;
	 x=320-dimx/2;
	 y=100;

	 raton.OcultaCursor();
	 ventana_reglas();
	 raton.MuestraCursor();
	 int variable= -1;

   raton_boton = 3 ;
	 do
		{
		 entrada();
     if ( cambio == 1)
     	{
       cambio = 0;
       raton_boton = ( raton_boton + 4 ) % 4 ;
       if ( raton_boton == 3)
       	raton.FijaPosicion(x + 445, y + 80 );
       if ( raton_boton == 2)
       	raton.FijaPosicion(x + 280, y + 80 );
       if ( raton_boton == 1)
       	raton.FijaPosicion(x + 115, y + 80 );
       if ( raton_boton == 0)
       	raton.FijaPosicion(x + 570, y + 40 );



      }

		 posx = raton.PosicionHorizontal();
		 posy = raton.PosicionVertical();
		 if ( !bi)
			{
			 if((posx > x + 435) && (posx < x + 435+60) && (posy >y + 70)&&(posy < y + 100))
				{
				 if ( ultimo != 1)
					{
					 mensaje("");
					 mensaje("Eliminar la regla seleccionada");
					 ultimo = 1;
					}
				}
			 else
				if((posx > x + 270) && (posx < x + 330) && (posy >y + 70)&&(posy < y + 100))
					{
					 if ( ultimo != 2)
						{
						 mensaje("");
						 mensaje("Editar la regla seleccionada");
						 ultimo = 2;
						}
					}
				else
					if((posx > x + 105) && (posx < x + 105+60) && (posy >y + 70)&&(posy < y + 100))
						{
						 if ( ultimo != 3)
							{
							 mensaje("");
							 mensaje("Crear una nueva regla");
							 ultimo = 3;
							}
						}
					else
						if ( ultimo != -1)
							{
							 mensaje("");
							 ultimo = -1;
							}
			}
		 if(bi)
			{
			 mensaje("");
			 ultimo = -1;
			 if((posx > x+560) && (posx < x+580) && (posy >y+30)&&(posy < y+50))
				 {  // elegir una varible
					raton.OcultaCursor();
					activar_boton(x+560,y+30,20,20,2);
					raton.MuestraCursor();
					if (lista_reglas == NULL)
					 {
						Ventana_errores("No existen reglas","","definidas en el sistema"); //botones.cpp
						bd = bc = 0;
						raton.OcultaCursor();
						desactivar_boton(x+560,y+30,20,20,2);
						raton.MuestraCursor();
					 }
					else
					 {
						int i=0,TEMP;
						int vbles =0;

						p = lista_reglas;
						while(p != NULL)
						{
						 names[i] = (char far *)farmalloc(500);
						 names[i][0] = 0;
						 crear_regla(p->reg,names[i]);
						 i ++;
						 p =p->next;
						}
					 vbles = i;
					 TEMP= barra(x+80,y+50,480,(char * *)names,i,0,3);
					 raton.OcultaCursor();
					 if(TEMP!=-1)
						{
						 raton.OcultaCursor();
						 dibujar_boton(x+80,y+30,480,20,2,WHITE,1);
						 setcolor(BLACK);
						 settextjustify(LEFT_TEXT,TOP_TEXT);
						 setviewport(x+80,y+30,x+80+480,y+50,1);
						 outtextxy(5,6,names[TEMP]);
						 setviewport(0,0,getmaxx()-1,getmaxy()-1,1);
						 variable = TEMP;
						}
					 raton.OcultaCursor();
					 desactivar_boton(x+560,y+30,20,20,2);
					 raton.MuestraCursor();
					 for ( i = 0; i < vbles;i ++)
						farfree(names[i]);

					 }
				}

			if((posx > x + 435) && (posx < x + 435 + 60) && (posy >y + 70)&&(posy < y + 100))
				{  // borrar
				 raton.OcultaCursor();
				 activar_boton(x + 435 , y+70,60,30,2);

				 if ( variable == -1)
					{
					 delay(100);
					 Ventana_errores("No existen una","regla selecionada","para ser borrada");//botones.cpp
					 bd = bc = 0;
					 raton.OcultaCursor();
					 desactivar_boton(x + 435 , y+70,60,30,2);
					 raton.MuestraCursor();
					}
				 else
					{
					 int i=0;
					 char buff[500];
					 lis_reg *q;
					 p = lista_reglas;

					 while((p != NULL) && ( i < variable))
						{
						 i ++;
						 q = p;
						 p =p->next;
						}
					 buff[0] = 0;
					 crear_regla(p->reg,buff);
					 if (Ventana_confirmacion("Borrar Variable","Desea borrar","la varible",buff) == 1)
						{
						 if ( p == lista_reglas)
							 lista_reglas = p->next;
						 else
							 q->next = p->next;

						 liberar_regla(p->reg);
						 farfree(p);
						 raton.OcultaCursor();
						 dibujar_boton(x+80,y+30,480,20,2,WHITE,1);
						 variable = -1;
						}
					 raton.OcultaCursor();
					 desactivar_boton(x + 435 , y+70,60,30,2);
					 raton.MuestraCursor();

					}

				}

			 if((posx > x + 270) && (posx < x + 330) && (posy >y + 70)&&(posy < y + 100))
				{ // editar
				 raton.OcultaCursor();
				 activar_boton(x + 270 , y+70,60,30,2);
				 if ( variable == -1)
					{
					 delay(100);
					 Ventana_errores("No existen una","regla selecionada","para ser editada");//botones.cpp
					 bd = bc = 0;
					 raton.OcultaCursor();
					 desactivar_boton(x + 270 , y+70,60,30,2);
					 raton.MuestraCursor();
					}
				 else
					{
					 int i=0;
					 char temp;

					 p = lista_reglas;
           q = p;
					 while((p != NULL) && ( i < variable))
						{
						 i ++;
             q = p;
						 p =p->next;
						}
					 if( editar_regla(p)== 1)
						{
						 raton.OcultaCursor();
						 dibujar_boton(x+80,y+30,480,20,2,WHITE,1);
						 setcolor(BLACK);
						}
           else
						{
						 if ( p == lista_reglas)
							 lista_reglas = p->next;
						 else
							 q->next = p->next;

						 liberar_regla(p->reg);
						 farfree(p);
						}
					 raton.OcultaCursor();
					 desactivar_boton(x+ 270 , y+70,60,30,2);
					 bd=bc= 0 ;
					 variable = -1 ;
					 dibujar_boton(x+80,y+30,480,20,2,WHITE,1);
					 raton.MuestraCursor();

					}
				}
			 if((posx > x + 105) && (posx < x + 135+60) && (posy >y + 70)&&(posy < y + 100))
				{  // crear
				 raton.OcultaCursor();
				 activar_boton(x + 105 , y+70,60,30,2);
				 p = (lis_reg *)farmalloc(sizeof(lis_reg));
				 if ( p == NULL)
					{
					 printf("ERROR: Memoria insuficiente");
					 exit(-1);
					}
				 p->reg = NULL;
				 p->next = NULL;
				 if ( editar_regla(p) == 1)
					{
					 lis_reg *q;
					 raton.OcultaCursor();
					 dibujar_boton(x+80,y+30,480,20,2,WHITE,1);
					 if ( lista_reglas == NULL)
						{
						 lista_reglas = p;
						}
					 else
						{
						 q = lista_reglas;
						 while ( q->next != NULL)
							q= q->next;
						 q->next = p;
						}

					}
				 else
					{
					 raton.OcultaCursor();
					 farfree(p);
					 dibujar_boton(x+80,y+30,480,20,2,WHITE,1);
					}
				 raton.OcultaCursor();
				 desactivar_boton(x + 105 , y+70,60,30,2);
				 raton.MuestraCursor();
				 bd=bc= 0 ;
				 variable = -1 ;
				}
			}
		}
	 while(!(bd||bc));
	 raton.OcultaCursor();
	 putimage(x,y,buf1,COPY_PUT);
	 dibujar_boton(10,70,620,375,2,LIGHTGRAY,1);
	 raton.MuestraCursor();
	}


void pant_regla(void)
	{
	 extern unsigned char far *buf1;
	 extern unsigned char far *buf2;
	 extern unsigned char far *buf3;

	 int x=0,y=0,dimx=0,dimy=0;

	 dimx=600;
	 dimy=214;
	 x=320-dimx/2;
	 y=100;

	 getimage(x,y,x+dimx,y+dimy,buf2);


	 dibujar_boton(x,y,dimx,dimy,2,LIGHTGRAY,0);  // Recuadro total
	 dibujar_boton(x+3,y+3,dimx-6,20,2,CYAN,1); // Titulo
	 settextjustify(CENTER_TEXT,CENTER_TEXT);
	 setcolor(WHITE);
	 outtextxy(x+dimx/2,y+13,"EDITAR REGLA");

	 setcolor(BLACK);
	 settextjustify(LEFT_TEXT,CENTER_TEXT);
	 outtextxy(x+10,y+40,"Regla :");
	 dibujar_boton(x+5,y+60,590,50,2,WHITE,1);

	 dibujar_boton(x + 33 , y+120,80,30,2,LIGHTGRAY,0);
	 setcolor(BLACK);
	 settextjustify(CENTER_TEXT,CENTER_TEXT);
	 outtextxy(x+73,y+135,"Insertar");

	 dibujar_boton(x + 147 , y+120,80,30,2,LIGHTGRAY,0);
	 setcolor(BLACK);
	 settextjustify(CENTER_TEXT,CENTER_TEXT);
	 outtextxy(x+187,y+135,"Variable");

	 dibujar_boton(x + 260 , y+120,80,30,2,LIGHTGRAY,0); /* nueva */
	 setcolor(BLACK);
	 settextjustify(CENTER_TEXT,CENTER_TEXT);
	 outtextxy(x+300,y+135,"Pertenece");

	 dibujar_boton(x + 373 , y+120,80,30,2,LIGHTGRAY,0);
	 setcolor(BLACK);
	 settextjustify(CENTER_TEXT,CENTER_TEXT);
	 outtextxy(x+413,y+135,"Conjunto");

	 dibujar_boton(x + 487 , y+120,80,30,2,LIGHTGRAY,0);
	 setcolor(BLACK);
	 settextjustify(CENTER_TEXT,CENTER_TEXT);
	 outtextxy(x+527,y+135,"Operador");


	 dibujar_boton(x + 33 , y+170,80,30,2,LIGHTGRAY,0);
	 setcolor(BLACK);
	 outtextxy(x+70,y+185,"Borrar");

	 dibujar_boton(x + 487 , y+170,80,30,2,LIGHTGRAY,0); /* ok */
	 setcolor(BLACK);
	 settextjustify(CENTER_TEXT,CENTER_TEXT);
	 outtextxy(x+527,y+185,"OK");

	}


void pintar_regla(regla *r)
	{
	 char buf[500];
	 int x=0,y=0,dimx=0,dimy=0;

	 dimx=600;
	 x=320-dimx/2;
	 y=100;

	 dibujar_boton(x+5,y+60,590,50,2,WHITE,1);
	 setcolor(BLACK);
	 settextjustify(LEFT_TEXT,CENTER_TEXT);
	 outtextxy(x+10,y+68,"SI");
	 outtextxy(x+10,y+88,"ENTONCES");
	 if ( r == NULL)
		return;

	 buf[0] = 0;

	 crear_regla(r->nodo.nohoja.izq,buf);
	 setviewport(x,y,x+5+580, y+60+ 50,1);
	 outtextxy(10,78,buf);
	 buf[0] = 0;
	 crear_regla(r->nodo.nohoja.der,buf);
	 setviewport(x,y,x+5+580, y+60+ 50,1);
	 outtextxy(10,98,buf);
	 setviewport(0,0,getmaxx()-1,getmaxy()-1,1);
	}


regla * buscar_no_or(regla *r)
	{
	 if ( r->nodo.nohoja.der->operador != OR)
		 return r;
	 else
		return (buscar_no_or(r->nodo.nohoja.der));
	}


char editar_regla(lis_reg *r)
	{
	 extern unsigned char far *buf1;
	 extern unsigned char far *buf2;
	 extern unsigned char far *buf3;
	 extern vble *vble_entrada;
	 extern vble *vble_salida;
	 extern lis_reg *lista_reglas;
   extern int raton_boton;
   extern int cambio;

	 extern GRaton raton;
	 extern int bi,bd,bc;
	 char *names[255];

	 int x,y,dimx,posx,posy;
	 int ultimo= -1;


	 dimx=600;
	 x=320-dimx/2;
	 y=100;

	 raton.OcultaCursor();
	 pant_regla();
	 pintar_regla(r->reg);
	 raton.MuestraCursor();
	 int variable= -1;
   raton_boton = 2;
	 do
		{
		 entrada();
     if ( cambio == 1)
     	{
       cambio = 0;
       raton_boton = ( raton_boton + 3) % 3;
       if ( raton_boton == 0)
				raton.FijaPosicion(x + 43, y + 130 );
       if ( raton_boton == 1)
				raton.FijaPosicion(x + 43, y + 180 );
       if ( raton_boton == 2)
				raton.FijaPosicion(x + 497, y + 180 );
      }
		 posx = raton.PosicionHorizontal();
		 posy = raton.PosicionVertical();
		 if ( !bi)
			{
			 if((posx > x + 33) && (posx < x + 33+80) && (posy >y + 120)&&(posy < y + 150))
				{
				 if ( ultimo != 1)
					{
					 mensaje("");
					 mensaje("Introducir un nuevo operando en la regla");
					 ultimo = 1;
					}
				}
			 else
				if((posx > x + 33) && (posx < x + 33+80) && (posy >y + 170)&&(posy < y + 200))
					{
					 if ( ultimo != 2)
						{
						 mensaje("");
						 mensaje("Eliminar un operando de la regla");
						 ultimo = 2;
						}
					}
					else
						if ( ultimo != -1)
							{
							 mensaje("");
							 ultimo = -1;
							}
			}
		 if(bi)
			{
			 mensaje("");
			 ultimo = -1;
			 if((posx > x + 33) && (posx < x + 33+80) && (posy >y + 120)&&(posy < y + 150))
				 {  // insertar oprarando
					// elegir variable
				  vble *v;
				  cnj_fuzzy *c;
				  int i=0,TEMP;
				  vble *p;
				  char per;
				  int vbles =0;
				  p = vble_entrada;
				  int cnjs = 0;

				  raton.OcultaCursor();
				  activar_boton(x+33,y+120,80,30,2);
				  activar_boton(x+147,y+120,80,30,2);
				  raton.MuestraCursor();

				  //******************* VARIABLE ***************//
				  if ((vble_entrada == NULL) && ( vble_salida == NULL))
					{
					  Ventana_errores("No existen Variable","","definidas en el sistema"); //botones.cpp
					  bd = bc = 0;
					  raton.OcultaCursor();
					  desactivar_boton(x+33,y+120,80,30,2);
					  desactivar_boton(x+147,y+120,80,30,2);
					  raton.MuestraCursor();
					  continue;
					}

				  while(p != NULL)
					{
					 names[i] = (char *)farmalloc(strlen(p->nombre));
					 strcpy(names[i],p->nombre);
					 i ++;
					 p =p->next;
					}
				  p = vble_salida;

				  while(p != NULL)
					 {
					  names[i] = (char *)farmalloc(strlen(p->nombre));
					  strcpy(names[i],p->nombre);
					  i ++;
					  p =p->next;
					 }

				  vbles = i;
				  TEMP= barra(x+147,y+150,260,(char * *)names,i,0,4);
				  raton.OcultaCursor();
				  if(TEMP == -1)
					{
					 bd = bc = 0;
					 raton.OcultaCursor();
					 desactivar_boton(x+33,y+120,80,30,2);
					 desactivar_boton(x+147,y+120,80,30,2);
					 raton.MuestraCursor();
					 continue;
					}
				  for ( i = 0; i < vbles;i ++)
				  farfree(names[i]);
				  v = vble_entrada;
				  i = 0;
				  while((v != NULL) && ( i < TEMP))
					{
					 i ++;
					 v =v->next;
					}
				  if (v == NULL )
					{
					 v = vble_salida;
					 while ((v != NULL) && ( i < TEMP))
						{
						 i ++;
						 v = v->next;
						}
					}
				  desactivar_boton(x+147,y+120,80,30,2);

				//*****************pertenencia*****************//
				  if ( v->tipo == ENTRADA)
					{
					 activar_boton(x + 260,y + 120, 80, 30, 2);
					 names[0] = (char *) farmalloc(40);
					 names[1] = (char *) farmalloc(40);
					 strcpy(names[0],"Pertenece");
					 strcpy(names[1],"No pertenece");
					 TEMP = barra(x + 260,y+150,260,(char * *)names,2,0,4);
					 if(TEMP == -1)
						 {
						  bd = bc = 0;
						  raton.OcultaCursor();
						  desactivar_boton(x+33,y+120,80,30,2);
						  desactivar_boton(x+260,y+120,80,30,2);
						  raton.MuestraCursor();
						  continue;
						 }

					 per = TEMP;
					 raton.OcultaCursor();
					 desactivar_boton(x+260,y+120,80,30,2);
					}
				//**************** conjuntos **********************//

				  activar_boton(x+373,y+120,80,30,2);
				  raton.MuestraCursor();
				  if (v->conjuntos == NULL)
					 {

					  raton.OcultaCursor();
					  Ventana_errores("No existen conjuntos","","definidos para esta variable"); //botones.cpp
					  bd = bc = 0;
					  raton.OcultaCursor();
					  desactivar_boton(x+33,y+120,80,30,2);
					  desactivar_boton(x+373,y+120,80,30,2);
					  raton.MuestraCursor();
					  continue;
					 }
				  i = 0;
				  c = v->conjuntos;

				  while(c != NULL)
					 {
					  names[i] = (char *)farmalloc(strlen(c->nombre));
					  strcpy(names[i],c->nombre);
					  i ++;
					  c = c->next;
					 }
				  cnjs = i;

				  TEMP= barra(x+300,y+150,260,(char * *)names,i,0,3);
				  raton.OcultaCursor();
				  if(TEMP ==-1)
					  {
						bd = bc = 0;
						raton.OcultaCursor();
						desactivar_boton(x+33,y+120,80,30,2);
						desactivar_boton(x+373,y+120,80,30,2);
						raton.MuestraCursor();
						continue;

					  }
				  c = v->conjuntos;
				  i = 0;
				  while( (c != NULL) && ( i < TEMP))
					  {
						  i ++;
						  c =c->next;
					  }
				  raton.OcultaCursor();
				  desactivar_boton(x+373,y+120,80,30,2);
				  raton.MuestraCursor();
				  for ( i = 0; i < cnjs;i ++)
						 farfree(names[i]);

				  //*******  operador  ************//
				  if ( r->reg == NULL)
					{
					 r->reg = (regla *) farmalloc(sizeof(regla));
					 if ( r->reg == NULL)
						{
						 printf("ERROR: memoria insuficiente");
						 exit(-1);
						}
					 r->reg->operador = EQ;
					 r->reg->nodo.nohoja.izq = NULL;
					 r->reg->nodo.nohoja.der = NULL;
					}

				  if ( v->tipo == SALIDA)
					{
					 regla *temp;
					 if (r->reg->nodo.nohoja.der != NULL)
						{
						 raton.OcultaCursor();
						 Ventana_errores("La regla ya tiene","", "una parte derecha");
						 bd = bc = 0;
						 raton.OcultaCursor();
						 desactivar_boton(x+33,y+120,80,30,2);
						 raton.MuestraCursor();
						 raton.MuestraCursor();
						 continue;
						}

					 temp = (regla *)farmalloc( sizeof(regla));
					 if ( temp == NULL)
						{
						 printf("ERROR : memoria insuficiente");
						 exit(-1);
						}
					 temp->operador = PER;
					 temp->nodo.hoja.variable = v;
					 temp->nodo.hoja.cnj = c;
					 r->reg->nodo.nohoja.der = temp;
					 pintar_regla(r->reg);

					}
				  else
					{
					 regla *hoja,*not;
					 hoja = (regla *)farmalloc( sizeof(regla));
					 if ( hoja == NULL)
						{
						 printf("ERROR : memoria insuficiente");
						 exit(-1);
						}
					 hoja->operador = PER;
					 hoja->nodo.hoja.variable = v;
					 hoja->nodo.hoja.cnj = c;
					 if ( per == 1)
						{
						 not = (regla *)farmalloc( sizeof(regla));
						 if ( not == NULL)
							{
							 printf("ERROR : memoria insuficiente");
							 exit(-1);
							}
						 not->operador = NOT;
						 not->nodo.nohoja.izq = hoja;
						 hoja = not;
						}
					 if ( r->reg->nodo.nohoja.izq == NULL)
						{
						 r->reg->nodo.nohoja.izq = hoja;
						 pintar_regla(r->reg);
						}
					 else
						{
						 char *names[2] = { "AND","OR"};


						 activar_boton(x+487,y+120,80,30,2);
						 TEMP = barra(x + 310,y+150,260,(char * *)names,2,0,3);
						 if(TEMP == -1)
							 {
							  bd = bc = 0;
							  raton.OcultaCursor();
							  desactivar_boton(x+33,y+120,80,30,2);
							  desactivar_boton(x+487,y+120,80,30,2);
							  if ( hoja->operador == NOT)
								{
								 farfree(hoja->nodo.nohoja.izq);
								}
							  farfree(hoja);
							  raton.MuestraCursor();
							  continue;
							 }
						 if (TEMP == 1) // OR
							{
							 regla *nohoja;

							 nohoja = (regla *) farmalloc( sizeof(regla));
							 if ( nohoja == NULL)
								{
								 printf("ERROR : memoria insuficiente");
								 exit(-1);
								}
							 nohoja->operador = OR;
							 nohoja->nodo.nohoja.izq = r->reg->nodo.nohoja.izq;
							 nohoja->nodo.nohoja.der = hoja;
							 r->reg->nodo.nohoja.izq = nohoja;

							 pintar_regla(r->reg);
							}
						 else
							{
							 regla *nohoja,*temp;

							 nohoja = (regla *) farmalloc( sizeof(regla));
							 if ( nohoja == NULL)
								{
								 printf("ERROR : memoria insuficiente");
								 exit(-1);
								}
							 if ( r->reg->nodo.nohoja.izq->operador != OR)
								{
								 nohoja->operador = AND;
								 nohoja->nodo.nohoja.izq = r->reg->nodo.nohoja.izq;
								 nohoja->nodo.nohoja.der = hoja;
								 r->reg->nodo.nohoja.izq = nohoja;

								}
							 else
								{
								 temp = buscar_no_or(r->reg->nodo.nohoja.izq);
								 nohoja->operador = AND;
								 nohoja->nodo.nohoja.izq = temp->nodo.nohoja.der;
								 nohoja->nodo.nohoja.der = hoja;
								 temp->nodo.nohoja.der = nohoja;
								}
							 pintar_regla(r->reg);

							}
						}

					}
				 raton.OcultaCursor();
				 desactivar_boton(x+33,y+120,80,30,2);
				 desactivar_boton(x+487,y+120,80,30,2);
				 raton.MuestraCursor();

				}

			 if((posx > x + 33) && (posx < x + 33+80) && (posy >y + 170)&&(posy < y + 200))
				{  // borrar un operando
				 raton.OcultaCursor();
				 activar_boton(x + 33 , y+170,80,30,2);

				 if ( (r->reg == NULL) ||
						((r->reg->nodo.nohoja.izq == NULL) && (r->reg->nodo.nohoja.der == NULL)))
					{
					 delay(100);
					 Ventana_errores("No existen","operandos en la regla","para ser borrados");
					 bd = bc = 0;
					 raton.OcultaCursor();
					 desactivar_boton(x + 33 , y+170,80,30,2);
					 raton.MuestraCursor();
					}
				 else
					{
					 int i=0;
					 char buff[500];
					 lis_reg *q;
					 char *names[255];
					 int cont = 0;
					 int TEMP;


					 encontrar_hojas(r->reg, names,&cont);
					 TEMP = barra(x + 33,y+200,300,(char * *)names,cont,0,3);
					 if ( TEMP == -1)
						{
						 bd = bc = 0;
						 raton.OcultaCursor();
						 desactivar_boton(x + 33 , y+170,80,30,2);
						 raton.MuestraCursor();
						}
					 else
						{
						 borrar(r->reg,TEMP);
						 raton.OcultaCursor();
						 pintar_regla(r->reg);
						 raton.MuestraCursor();
						}
					 raton.OcultaCursor();
					 desactivar_boton(x + 33 , y+170,80,30,2);
					 raton.MuestraCursor();
					}
				}

			 if((posx > x + 487) && (posx < x + 487+80) && (posy >y + 170)&&(posy < y + 200))
				{
				 raton.OcultaCursor();
				 activar_boton(x + 487 , y+170,80,30,2); /* ok */
				 raton.MuestraCursor();
				 if ( (r->reg->nodo.nohoja.izq == NULL) || (r->reg == NULL))
					{
					 Ventana_errores("La regla no tiene","","parte izquierda");
					 raton.OcultaCursor();
					 desactivar_boton(x + 487 , y+170,80,30,2);
					 raton.MuestraCursor();
					 continue;
					}
				 if ( r->reg->nodo.nohoja.der == NULL)
					{
					 Ventana_errores("La regla no tiene","","parte derecha");
					 raton.OcultaCursor();
					 desactivar_boton(x + 487 , y+170,80,30,2);
					 raton.MuestraCursor();
					 continue;
					}
				 raton.OcultaCursor();
				 putimage(x,y,buf2,COPY_PUT);
				 raton.MuestraCursor();
				 return 1;
				}
			}
    if ( bd || bc)
			{
       if (Ventana_confirmacion("Ventana reglas","Si escapa de este ventana la","regla editada se borrar,"," desea salir ?"))
				{
         bi = bc = 0;
	       raton.OcultaCursor();
	       putimage(x,y,buf2,COPY_PUT);
         raton.MuestraCursor();
         return 0;
				}
			}

		}
	 while( 1);
	}