#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include "struct.hpp"

double calculo_regla(regla r);      // motor_i.cpp
void init_cnj(cnj_fuzzy & cnj);     // motor_i.cpp
double media_producto_suma(vble v); // motor_i.cpp
void mensaje(char *texto); // botones.cpp
void valor_entrada(vble v, double valor ); // motor_i.cpp
void Ventana_errores(char * Linea1,char *Linea2,char *Linea3); //botones.cpp


void sim(void)
	{

	 extern vble *vble_entrada;
	 extern vble *vble_salida;
	 extern lis_reg *lista_reglas;
	 int n_entradas ;
	 int n_salidas  ;
	 int i;
	 FILE **desc;
	 vble *p;
	 char fin = 0;
	 int cont;


	 // contar variables de entrada

	 p = vble_entrada;
	 n_entradas= 0;
	 while ( p != NULL)
		{
		 n_entradas ++;
		 p = p->next;
		}

	 if ( vble_entrada == 0 )
		{
		 Ventana_errores("No existen variables de entrada","", "definidas en este sistema");
		 return;
		}
	 // contar variables de salida

	 p = vble_salida;
	 n_salidas= 0;
	 while ( p != NULL)
		{
		 n_salidas ++;
		 p = p->next;
		}

	 if ( vble_salida == 0 )
		{
		 Ventana_errores("No existen variables de salida","", "definidas en este sistema");
		 return;
		}


	// comprobar que todas tienen ficheros asociados y abrirlos

	desc = (FILE **) farmalloc( sizeof(FILE *)*( n_entradas+n_salidas));
	if ( desc == NULL)
		{
		 printf("ERROR: memoria insuficiente");
		 exit(-1);
		}
	p = vble_entrada;
	i = 0;
	while ( p != NULL)
		{
		 if ( p->fichero[0] == 0)
			{
			 char buff[255];
			 sprintf(buff,"La variable %s",p->nombre);
			 Ventana_errores(buff,"","no tiene asosiado ningn fichero");
			 farfree(desc);
			 return;
			}
		 desc[i] = fopen(p->fichero,"r");
		 if ( desc[i] == NULL)
			{
			 char buf[255];
			 sprintf(buf,"%s",p->fichero);
			 Ventana_errores("Error intentando", "abrir el fichero",buf);
			 farfree(desc);
			 return;
			}
		 i ++;
		 p = p->next;
		}

	p = vble_salida;
	while ( p != NULL)
		{
		 if ( p->fichero[0] == 0)
			{
			 char buff[255];
			 sprintf(buff,"La variable %s",p->nombre);
			 Ventana_errores(buff,"","no tiene asosiado ningn fichero");
			 farfree(desc);
			 return;
			}
		 desc[i] = fopen(p->fichero,"w");
		 if ( desc[i] == NULL)
			{
			 char buf[255];
			 sprintf(buf,"%s",p->fichero);
			 Ventana_errores("Error intentando", "abrir el fichero",buf);
			 farfree(desc);
			 return;
			}
		 i ++;
		 p = p->next;
		}

	  // inicializar los conjuntos

	 p = vble_entrada;
	 while ( p != NULL)
		{
		 cnj_fuzzy *c;
		 c = p->conjuntos;
		 while ( c != NULL)
			{
			 init_cnj(*c);
			 c = c->next;
			}
		 p = p->next;
		}

	 p = vble_salida;
	 while ( p != NULL)
		{
		 cnj_fuzzy *c;
		 c = p->conjuntos;
		 while ( c != NULL)
			{
			 init_cnj(*c);
			 c = c->next;
			}
		 p = p->next;
		}


	 cont = 0;
	 while ( fin == 0)
		{
		 lis_reg *l;
		 char buf[255];

		 cont ++;
		 sprintf(buf,"Interacciones realizadas : %d",cont);
		 mensaje(buf);
		 p = vble_entrada;
		 for ( i =0; i < n_entradas; i ++, p = p->next )
			{
			 double temp;
			 if ( feof(desc[i]) )
				{
				 fin = 1;
				 break;
				}
			 fscanf (desc[i],"%lf",&temp);
			 valor_entrada(*p,temp);
			}
		 if ( fin == 1)
			continue;

		 l = lista_reglas;

		 while(l != NULL)
			{
			 calculo_regla(*(l->reg));
			 l = l->next;
			}

		 p = vble_salida;
		 for ( i =n_entradas; i < (n_entradas + n_salidas); i ++, p = p->next )
			{
			 double temp;
			 temp = media_producto_suma(*p);
			 fprintf(desc[i],"\n%lf",temp);
			}
		}

	for ( i = 0; i < n_entradas + n_salidas ;  i ++)
		{
		 fclose(desc[i]);
		}
	farfree(desc);
	mensaje("");
  }
